Index: src/backend/commands/operatorcmds.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/commands/operatorcmds.c,v
retrieving revision 1.3
diff -c -r1.3 operatorcmds.c
*** src/backend/commands/operatorcmds.c	2002/04/27 03:45:01	1.3
--- src/backend/commands/operatorcmds.c	2002/06/15 16:38:11
***************
*** 37,44 ****
  #include "access/heapam.h"
  #include "catalog/catname.h"
  #include "catalog/namespace.h"
  #include "catalog/pg_operator.h"
- #include "commands/comment.h"
  #include "commands/defrem.h"
  #include "miscadmin.h"
  #include "parser/parse_oper.h"
--- 37,44 ----
  #include "access/heapam.h"
  #include "catalog/catname.h"
  #include "catalog/namespace.h"
+ #include "catalog/pg_depend.h"
  #include "catalog/pg_operator.h"
  #include "commands/defrem.h"
  #include "miscadmin.h"
  #include "parser/parse_oper.h"
***************
*** 208,213 ****
--- 208,214 ----
  
  /*
   * RemoveOperator
+  * RemoveOperatorById
   *		Deletes an operator.
   *
   * Exceptions:
***************
*** 219,233 ****
  void
  RemoveOperator(List *operatorName,		/* operator name */
  			   TypeName *typeName1, /* left argument type name */
! 			   TypeName *typeName2) /* right argument type name */
  {
  	Oid			operOid;
- 	Relation	relation;
- 	HeapTuple	tup;
  
  	operOid = LookupOperNameTypeNames(operatorName, typeName1, typeName2,
  									  "RemoveOperator");
  
  	relation = heap_openr(OperatorRelationName, RowExclusiveLock);
  
  	tup = SearchSysCacheCopy(OPEROID,
--- 220,241 ----
  void
  RemoveOperator(List *operatorName,		/* operator name */
  			   TypeName *typeName1, /* left argument type name */
! 			   TypeName *typeName2, /* right argument type name */
! 			   int behavior)
  {
  	Oid			operOid;
  
  	operOid = LookupOperNameTypeNames(operatorName, typeName1, typeName2,
  									  "RemoveOperator");
  
+ 	RemoveOperatorById(operOid, behavior);
+ }
+ 
+ void
+ RemoveOperatorById(Oid operOid, int behavior)
+ {
+ 	Relation	relation;
+ 	HeapTuple	tup;
  	relation = heap_openr(OperatorRelationName, RowExclusiveLock);
  
  	tup = SearchSysCacheCopy(OPEROID,
***************
*** 235,250 ****
  							 0, 0, 0);
  	if (!HeapTupleIsValid(tup))	/* should not happen */
  		elog(ERROR, "RemoveOperator: failed to find tuple for operator '%s'",
! 			 NameListToString(operatorName));
  
  	/* Permission check: must own operator or its namespace */
  	if (!pg_oper_ownercheck(operOid, GetUserId()) &&
  		!pg_namespace_ownercheck(((Form_pg_operator) GETSTRUCT(tup))->oprnamespace,
  								 GetUserId()))
! 		aclcheck_error(ACLCHECK_NOT_OWNER, NameListToString(operatorName));
  
! 	/* Delete any comments associated with this operator */
! 	DeleteComments(operOid, RelationGetRelid(relation));
  
  	simple_heap_delete(relation, &tup->t_self);
  
--- 243,262 ----
  							 0, 0, 0);
  	if (!HeapTupleIsValid(tup))	/* should not happen */
  		elog(ERROR, "RemoveOperator: failed to find tuple for operator '%s'",
! 			 get_opname(operOid));
  
  	/* Permission check: must own operator or its namespace */
  	if (!pg_oper_ownercheck(operOid, GetUserId()) &&
  		!pg_namespace_ownercheck(((Form_pg_operator) GETSTRUCT(tup))->oprnamespace,
  								 GetUserId()))
! 		aclcheck_error(ACLCHECK_NOT_OWNER, get_opname(operOid));
! 
! 	if (!pg_oper_ownercheck(operOid, GetUserId()))
! 		elog(ERROR, "RemoveOperator: operator '%s': permission denied",
! 			 get_opname(operOid));
  
! 	/* Deal with dependencies */
! 	dependDeleteTuple(tup, relation, behavior);
  
  	simple_heap_delete(relation, &tup->t_self);
  
Index: src/backend/commands/proclang.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/commands/proclang.c,v
retrieving revision 1.33
diff -c -r1.33 proclang.c
*** src/backend/commands/proclang.c	2002/05/22 17:20:58	1.33
--- src/backend/commands/proclang.c	2002/06/15 16:38:11
***************
*** 18,23 ****
--- 18,24 ----
  #include "access/heapam.h"
  #include "catalog/catname.h"
  #include "catalog/indexing.h"
+ #include "catalog/pg_depend.h"
  #include "catalog/namespace.h"
  #include "catalog/pg_language.h"
  #include "catalog/pg_proc.h"
***************
*** 49,54 ****
--- 50,58 ----
  	TupleDesc	tupDesc;
  	int			i;
  
+ 	ObjectAddress	myself,
+ 					dependee;
+ 
  	/*
  	 * Check permission
  	 */
***************
*** 80,85 ****
--- 84,94 ----
  		elog(ERROR, "PL handler function %s() does not return type \"opaque\"",
  			 NameListToString(stmt->plhandler));
  
+ 	/* Address of the PL handler function */
+ 	dependee.classId = RelOid_pg_proc;
+ 	dependee.objectId = procOid;
+ 	dependee.objectSubId = 0;
+ 
  	/* validate the validator function */
  	if (stmt->plvalidator)
  	{
***************
*** 127,132 ****
--- 136,149 ----
  		CatalogCloseIndices(Num_pg_language_indices, idescs);
  	}
  
+ 	/* Address of myself */
+ 	myself.classId = RelationGetRelid(rel);
+ 	myself.objectId = tup->t_data->t_oid;
+ 	myself.objectSubId = 0;
+ 
+ 	/* Create dependency on the language PL Handler function */
+ 	dependCreate(&myself, &dependee, false);
+ 
  	heap_close(rel, RowExclusiveLock);
  }
  
***************
*** 166,171 ****
--- 183,191 ----
  	if (!((Form_pg_language) GETSTRUCT(langTup))->lanispl)
  		elog(ERROR, "Language %s isn't a created procedural language",
  			 languageName);
+ 
+ 	/* Deal with Dependencies */
+ 	dependDeleteTuple(langTup, rel, stmt->behavior);
  
  	simple_heap_delete(rel, &langTup->t_self);
  
Index: src/backend/commands/tablecmds.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/commands/tablecmds.c,v
retrieving revision 1.16
diff -c -r1.16 tablecmds.c
*** src/backend/commands/tablecmds.c	2002/05/21 22:05:54	1.16
--- src/backend/commands/tablecmds.c	2002/06/15 16:38:16
***************
*** 23,28 ****
--- 23,30 ----
  #include "catalog/indexing.h"
  #include "catalog/namespace.h"
  #include "catalog/pg_attrdef.h"
+ #include "catalog/pg_constraint.h"
+ #include "catalog/pg_depend.h"
  #include "catalog/pg_inherits.h"
  #include "catalog/pg_namespace.h"
  #include "catalog/pg_opclass.h"
***************
*** 240,248 ****
--- 242,275 ----
  	{
  		ColumnDef  *colDef = lfirst(listptr);
  		RawColumnDefault *rawEnt;
+ 		ObjectAddress   myself,
+ 						dependee;
  
  		attnum++;
  
+ 		myself.classId = RelOid_pg_class;
+ 		myself.objectId = relationId;
+ 		myself.objectSubId = attnum;
+ 
+ 		/*
+ 		 * Seek for serial dependency
+ 		 * The sequence must have been created first!
+ 		 */
+ 		if (colDef->typename->serial != NULL) {
+ 			ObjectAddress	depender;
+ 
+ 			depender.classId = RelOid_pg_class;
+ 			depender.objectId = RangeVarGetRelid(colDef->typename->serial, false);
+ 			depender.objectSubId = 0;
+ 			dependCreate(&depender, &myself, true);
+ 		}
+ 
+ 		/* Store the column dependency on the column type */
+ 		dependee.classId = RelOid_pg_type;
+ 		dependee.objectId = LookupTypeName(colDef->typename);
+ 		dependee.objectSubId = 0;
+ 		dependCreate(&myself, &dependee, false);
+ 
  		if (colDef->raw_default == NULL)
  			continue;
  		Assert(colDef->cooked_default == NULL);
***************
*** 280,291 ****
   * themselves will be destroyed, too.
   */
  void
! RemoveRelation(const RangeVar *relation)
  {
  	Oid			relOid;
  
  	relOid = RangeVarGetRelid(relation, false);
! 	heap_drop_with_catalog(relOid, allowSystemTableMods);
  }
  
  /*
--- 307,318 ----
   * themselves will be destroyed, too.
   */
  void
! RemoveRelation(const RangeVar *relation, int behavior)
  {
  	Oid			relOid;
  
  	relOid = RangeVarGetRelid(relation, false);
! 	heap_drop_with_catalog(relOid, allowSystemTableMods, behavior);
  }
  
  /*
***************
*** 736,742 ****
  /*
   * complementary static functions for MergeAttributes().
   *
!  * Varattnos of pg_relcheck.rcbin must be rewritten when subclasses inherit
   * constraints from parent classes, since the inherited attributes could
   * be given different column numbers in multiple-inheritance cases.
   *
--- 763,769 ----
  /*
   * complementary static functions for MergeAttributes().
   *
!  * Varattnos of pg_constraint.conbin must be rewritten when subclasses inherit
   * constraints from parent classes, since the inherited attributes could
   * be given different column numbers in multiple-inheritance cases.
   *
***************
*** 2592,2598 ****
  					trig.tgargs[0] = trig.tgname;
  					trig.tgargs[1] = RelationGetRelationName(rel);
  					trig.tgargs[2] = RelationGetRelationName(pkrel);
! 					trig.tgargs[3] = fkconstraint->match_type;
  					count = 4;
  					foreach(list, fkconstraint->fk_attrs)
  					{
--- 2619,2639 ----
  					trig.tgargs[0] = trig.tgname;
  					trig.tgargs[1] = RelationGetRelationName(rel);
  					trig.tgargs[2] = RelationGetRelationName(pkrel);
! 					switch (fkconstraint->match_type) 
! 					{
! 						case CONSTRAINT_FKEY_FULL:
! 							trig.tgargs[3] = "FULL";
! 							break;
! 						case CONSTRAINT_FKEY_PARTIAL:
! 							trig.tgargs[3] = "PARTIAL";
! 							break;
! 						case CONSTRAINT_FKEY_UNSPECIFIED:
! 							trig.tgargs[3] = "UNSPECIFIED";
! 							break;
! 						default:
! 							elog(ERROR, "constraintCreate: Unknown MATCH TYPE");
! 					}
! 
  					count = 4;
  					foreach(list, fkconstraint->fk_attrs)
  					{
***************
*** 2646,2651 ****
--- 2687,2702 ----
  
  					pfree(trig.tgargs);
  
+ 					/*
+ 					 * Call AddRelationRawConstraints to do
+ 					 * the real adding -- It duplicates some
+ 					 * of the above, but does not check the
+ 					 * validity of the constraint against
+ 					 * tuples already in the table.
+ 					 */
+ 					AddRelationRawConstraints(rel, NIL,
+ 											  makeList1(fkconstraint));
+ 
  					heap_close(pkrel, NoLock);
  
  					break;
***************
*** 2659,2691 ****
  	heap_close(rel, NoLock);
  }
  
- 
  /*
   * ALTER TABLE DROP CONSTRAINT
-  * Note: It is legal to remove a constraint with name "" as it is possible
-  * to add a constraint with name "".
-  * Christopher Kings-Lynne
   */
  void
! AlterTableDropConstraint(Oid myrelid,
  						 bool inh, const char *constrName,
  						 int behavior)
  {
! 	Relation	rel;
! 	int			deleted;
  
  	/*
- 	 * We don't support CASCADE yet  - in fact, RESTRICT doesn't work to
- 	 * the spec either!
- 	 */
- 	if (behavior == CASCADE)
- 		elog(ERROR, "ALTER TABLE / DROP CONSTRAINT does not support the CASCADE keyword");
- 
- 	/*
  	 * Acquire an exclusive lock on the target relation for the duration
  	 * of the operation.
  	 */
! 	rel = heap_open(myrelid, AccessExclusiveLock);
  
  	/* Disallow DROP CONSTRAINT on views, indexes, sequences, etc */
  	if (rel->rd_rel->relkind != RELKIND_RELATION)
--- 2710,2735 ----
  	heap_close(rel, NoLock);
  }
  
  /*
   * ALTER TABLE DROP CONSTRAINT
   */
  void
! AlterTableDropConstraint(Oid relId,
  						 bool inh, const char *constrName,
  						 int behavior)
  {
! 	Relation		rel;
! 	ScanKeyData		skey[2];
! 	SysScanDesc 	rcscan;
! 	int				i = 0;
! 	HeapTuple		tup;
! 	Relation		conDesc;
  
  	/*
  	 * Acquire an exclusive lock on the target relation for the duration
  	 * of the operation.
  	 */
! 	rel = heap_open(relId, AccessExclusiveLock);
  
  	/* Disallow DROP CONSTRAINT on views, indexes, sequences, etc */
  	if (rel->rd_rel->relkind != RELKIND_RELATION)
***************
*** 2697,2737 ****
  		elog(ERROR, "ALTER TABLE: relation \"%s\" is a system catalog",
  			 RelationGetRelationName(rel));
  
! 	if (!pg_class_ownercheck(myrelid, GetUserId()))
  		aclcheck_error(ACLCHECK_NOT_OWNER, RelationGetRelationName(rel));
  
- 	/*
- 	 * Since all we have is the name of the constraint, we have to look
- 	 * through all catalogs that could possibly contain a constraint for
- 	 * this relation. We also keep a count of the number of constraints
- 	 * removed.
- 	 */
  
! 	deleted = 0;
  
! 	/*
! 	 * First, we remove all CHECK constraints with the given name
! 	 */
  
! 	deleted += RemoveCheckConstraint(rel, constrName, inh);
  
! 	/*
! 	 * Now we remove NULL, UNIQUE, PRIMARY KEY and FOREIGN KEY
! 	 * constraints.
! 	 *
! 	 * Unimplemented.
! 	 */
  
! 	/* Close the target relation */
  	heap_close(rel, NoLock);
- 
- 	/* If zero constraints deleted, complain */
- 	if (deleted == 0)
- 		elog(ERROR, "ALTER TABLE / DROP CONSTRAINT: %s does not exist",
- 			 constrName);
- 	/* Otherwise if more than one constraint deleted, notify */
- 	else if (deleted > 1)
- 		elog(NOTICE, "Multiple constraints dropped");
  }
  
  /*
--- 2741,2776 ----
  		elog(ERROR, "ALTER TABLE: relation \"%s\" is a system catalog",
  			 RelationGetRelationName(rel));
  
! 	if (!pg_class_ownercheck(relId, GetUserId()))
  		aclcheck_error(ACLCHECK_NOT_OWNER, RelationGetRelationName(rel));
  
  
! 	/* Find the ID of our constraint */
! 	ScanKeyEntryInitialize(&skey[i++],
! 						   0, Anum_pg_constraint_conrelid, F_OIDEQ,
! 						   ObjectIdGetDatum(relId));
! 	ScanKeyEntryInitialize(&skey[i++],
! 						   0, Anum_pg_constraint_conname, F_NAMEEQ,
! 						   NameGetDatum(constrName));
! 
! 	conDesc = heap_openr(ConstraintRelationName, RowExclusiveLock);
! 	rcscan = systable_beginscan(conDesc, ConstraintRelidNameIndex, true,
! 								SnapshotNow,
! 								i, skey);
  
! 	tup = systable_getnext(rcscan);
  
! 	/* If the constraint doesn't exist then throw an error */
! 	if (!HeapTupleIsValid(tup))
! 		elog(ERROR, "ALTER TABLE / DROP CONSTRAINT: %s does not exist",
! 			 constrName);
  
! 	/* Call for removal of the constraint */
! 	DropConstraintById(tup->t_data->t_oid, behavior);
  
! 	/* Clean up and exit */
! 	systable_endscan(rcscan);
  	heap_close(rel, NoLock);
  }
  
  /*
Index: src/backend/commands/trigger.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/commands/trigger.c,v
retrieving revision 1.119
diff -c -r1.119 trigger.c
*** src/backend/commands/trigger.c	2002/05/24 18:57:55	1.119
--- src/backend/commands/trigger.c	2002/06/15 16:38:22
***************
*** 18,28 ****
  #include "catalog/catalog.h"
  #include "catalog/catname.h"
  #include "catalog/indexing.h"
  #include "catalog/namespace.h"
  #include "catalog/pg_language.h"
  #include "catalog/pg_proc.h"
  #include "catalog/pg_trigger.h"
- #include "commands/comment.h"
  #include "commands/trigger.h"
  #include "executor/executor.h"
  #include "miscadmin.h"
--- 18,28 ----
  #include "catalog/catalog.h"
  #include "catalog/catname.h"
  #include "catalog/indexing.h"
+ #include "catalog/pg_depend.h"
  #include "catalog/namespace.h"
  #include "catalog/pg_language.h"
  #include "catalog/pg_proc.h"
  #include "catalog/pg_trigger.h"
  #include "commands/trigger.h"
  #include "executor/executor.h"
  #include "miscadmin.h"
***************
*** 50,56 ****
  					   MemoryContext per_tuple_context);
  
  
! void
  CreateTrigger(CreateTrigStmt *stmt)
  {
  	int16		tgtype;
--- 50,56 ----
  					   MemoryContext per_tuple_context);
  
  
! Oid
  CreateTrigger(CreateTrigStmt *stmt)
  {
  	int16		tgtype;
***************
*** 71,79 ****
  	Oid			funclang;
  	int			found = 0;
  	int			i;
- 	char		constrtrigname[NAMEDATALEN];
  	char	   *constrname = "";
  	Oid			constrrelid = InvalidOid;
  
  	rel = heap_openrv(stmt->relation, AccessExclusiveLock);
  
--- 71,81 ----
  	Oid			funclang;
  	int			found = 0;
  	int			i;
  	char	   *constrname = "";
  	Oid			constrrelid = InvalidOid;
+ 	Oid			insertOid, insertTupOid;
+ 	ObjectAddress	myself,
+ 					dependee;
  
  	rel = heap_openrv(stmt->relation, AccessExclusiveLock);
  
***************
*** 89,111 ****
  						  stmt->isconstraint ? ACL_REFERENCES : ACL_TRIGGER);
  	if (aclresult != ACLCHECK_OK)
  		aclcheck_error(aclresult, RelationGetRelationName(rel));
- 
- 	/*
- 	 * If trigger is an RI constraint, use trigger name as constraint name
- 	 * and build a unique trigger name instead.
- 	 */
- 	if (stmt->isconstraint)
- 	{
- 		constrname = stmt->trigname;
- 		snprintf(constrtrigname, sizeof(constrtrigname),
- 				 "RI_ConstraintTrigger_%u", newoid());
- 		stmt->trigname = constrtrigname;
  
! 		if (stmt->constrrel != NULL)
! 			constrrelid = RangeVarGetRelid(stmt->constrrel, false);
! 		else
! 			constrrelid = InvalidOid;
! 	}
  
  	TRIGGER_CLEAR_TYPE(tgtype);
  	if (stmt->before)
--- 91,102 ----
  						  stmt->isconstraint ? ACL_REFERENCES : ACL_TRIGGER);
  	if (aclresult != ACLCHECK_OK)
  		aclcheck_error(aclresult, RelationGetRelationName(rel));
  
! 	/* Fetch the constraint relation */
! 	if (stmt->constrrel != NULL)
! 		constrrelid = RangeVarGetRelid(stmt->constrrel, false);
! 	else
! 		constrrelid = InvalidOid;
  
  	TRIGGER_CLEAR_TYPE(tgtype);
  	if (stmt->before)
***************
*** 229,235 ****
  		foreach(le, stmt->args)
  		{
  			char	   *ar = ((Value *) lfirst(le))->val.str;
- 
  			len += strlen(ar) + 4;
  			for (; *ar; ar++)
  			{
--- 220,225 ----
***************
*** 267,272 ****
--- 257,264 ----
  
  	tuple = heap_formtuple(tgrel->rd_att, values, nulls);
  
+ 	insertOid = tgrel->rd_id;
+ 
  	/*
  	 * Insert tuple into pg_trigger.
  	 */
***************
*** 274,279 ****
--- 266,275 ----
  	CatalogOpenIndices(Num_pg_trigger_indices, Name_pg_trigger_indices, idescs);
  	CatalogIndexInsert(idescs, Num_pg_trigger_indices, tgrel, tuple);
  	CatalogCloseIndices(Num_pg_trigger_indices, idescs);
+ 
+ 	/* Need the Inserted Tup Oid below for the address of 'myself' */
+ 	insertTupOid = tuple->t_data->t_oid;
+ 
  	heap_freetuple(tuple);
  	heap_close(tgrel, RowExclusiveLock);
  
***************
*** 302,307 ****
--- 298,331 ----
  	heap_close(pgrel, RowExclusiveLock);
  
  	/*
+ 	 * Insert dependencies
+ 	 */
+ 	myself.classId = insertOid;
+ 	myself.objectId = insertTupOid;
+ 	myself.objectSubId = 0;
+ 
+ 	/* tgrelid */
+ 	dependee.classId = RelOid_pg_class;
+ 	dependee.objectId = RelationGetRelid(rel);
+ 	dependee.objectSubId = 0;
+ 	dependCreate(&myself, &dependee, true);
+ 
+ 	/* tgfoid */
+ 	dependee.classId = RelOid_pg_proc;
+ 	dependee.objectId = funcoid;
+ 	dependee.objectSubId = 0;
+ 	dependCreate(&myself, &dependee, false);
+ 
+ 	/* tgconstrrelid */
+ 	if (constrrelid != InvalidOid)
+ 	{
+ 		dependee.classId = RelOid_pg_class;
+ 		dependee.objectId = constrrelid;
+ 		dependee.objectSubId = 0;
+ 		dependCreate(&myself, &dependee, true);
+ 	}
+ 
+ 	/*
  	 * We used to try to update the rel's relcache entry here, but that's
  	 * fairly pointless since it will happen as a byproduct of the
  	 * upcoming CommandCounterIncrement...
***************
*** 309,321 ****
  
  	/* Keep lock on target rel until end of xact */
  	heap_close(rel, NoLock);
  }
  
  /*
   * DropTrigger - drop an individual trigger by name
   */
  void
! DropTrigger(Oid relid, const char *trigname)
  {
  	Relation	rel;
  	Relation	tgrel;
--- 333,402 ----
  
  	/* Keep lock on target rel until end of xact */
  	heap_close(rel, NoLock);
+ 
+ 	return insertTupOid;
  }
  
+ char *
+ getTriggerName(Oid relId, char *prefix)
+ {
+ 	int			j = 1;
+ 	bool		success;
+ 	Relation	trgDesc;
+ 	HeapTuple	tup;
+ 	char	   *cname;
+ 
+ 	cname = palloc(NAMEDATALEN * sizeof(char));
+ 
+ 	trgDesc = heap_openr(TriggerRelationName, RowExclusiveLock);
+ 
+ 	if (prefix == NULL)
+ 		prefix = "trigger";
+ 
+ 	/* Loop until we find a non-conflicting constraint name */
+ 	/* What happens if this loops forever? */
+ 	do
+ 	{
+ 		int			i = 0;
+ 		SysScanDesc rcscan;
+ 		ScanKeyData skey[2];
+ 
+ 		success = false;
+ 
+ 		snprintf(cname, NAMEDATALEN, "%s_%d", prefix, j);
+ 
+ 		/* make sure there is no existing constraints of the same name */
+ 		ScanKeyEntryInitialize(&skey[i++],
+ 							   0, Anum_pg_trigger_tgrelid, F_OIDEQ,
+ 							   ObjectIdGetDatum(relId));
+ 
+ 		ScanKeyEntryInitialize(&skey[i++],
+ 							   0, Anum_pg_trigger_tgname, F_NAMEEQ,
+ 							   NameGetDatum(cname));
+ 
+ 		rcscan = systable_beginscan(trgDesc, TriggerRelidNameIndex, true,
+ 									SnapshotNow,
+ 									i, skey);
+ 
+ 		tup = systable_getnext(rcscan);
+ 		if (!HeapTupleIsValid(tup))
+ 			success = true;
+ 
+ 		systable_endscan(rcscan);
+ 		++j;
+ 	} while (!success);
+ 
+ 	/* Cleanup, but keep lock */
+ 	heap_close(trgDesc, NoLock);
+ 
+ 	return cname;
+ }
+ 
  /*
   * DropTrigger - drop an individual trigger by name
   */
  void
! DropTrigger(Oid relid, const char *trigname, int behavior)
  {
  	Relation	rel;
  	Relation	tgrel;
***************
*** 363,370 ****
  
  		if (namestrcmp(&(pg_trigger->tgname), trigname) == 0)
  		{
! 			/* Delete any comments associated with this trigger */
! 			DeleteComments(tuple->t_data->t_oid, RelationGetRelid(tgrel));
  
  			simple_heap_delete(tgrel, &tuple->t_self);
  			found++;
--- 444,451 ----
  
  		if (namestrcmp(&(pg_trigger->tgname), trigname) == 0)
  		{
! 			/* Deal with dependencies */
! 			dependDeleteTuple(tuple, tgrel, behavior);
  
  			simple_heap_delete(tgrel, &tuple->t_self);
  			found++;
***************
*** 408,505 ****
  }
  
  /*
!  * Remove all triggers for a relation that's being deleted.
   */
  void
! RelationRemoveTriggers(Relation rel)
  {
! 	Relation	tgrel;
! 	SysScanDesc	tgscan;
! 	ScanKeyData key;
! 	HeapTuple	tup;
! 	bool		found = false;
  
  	tgrel = heap_openr(TriggerRelationName, RowExclusiveLock);
! 	ScanKeyEntryInitialize(&key, 0,
! 						   Anum_pg_trigger_tgrelid,
  						   F_OIDEQ,
! 						   ObjectIdGetDatum(RelationGetRelid(rel)));
! 	tgscan = systable_beginscan(tgrel, TriggerRelidNameIndex, true,
! 								SnapshotNow, 1, &key);
  
! 	while (HeapTupleIsValid(tup = systable_getnext(tgscan)))
! 	{
! 		/* Delete any comments associated with this trigger */
! 		DeleteComments(tup->t_data->t_oid, RelationGetRelid(tgrel));
  
! 		simple_heap_delete(tgrel, &tup->t_self);
  
! 		found = true;
! 	}
  
! 	systable_endscan(tgscan);
  
! 	/*
! 	 * If we deleted any triggers, must update pg_class entry and advance
! 	 * command counter to make the updated entry visible. This is fairly
! 	 * annoying, since we'e just going to drop the durn thing later, but
! 	 * it's necessary to have a consistent state in case we do
! 	 * CommandCounterIncrement() below --- if RelationBuildTriggers()
! 	 * runs, it will complain otherwise. Perhaps RelationBuildTriggers()
! 	 * shouldn't be so picky...
! 	 */
! 	if (found)
! 	{
! 		Relation	pgrel;
! 		Relation	ridescs[Num_pg_class_indices];
  
! 		pgrel = heap_openr(RelationRelationName, RowExclusiveLock);
! 		tup = SearchSysCacheCopy(RELOID,
! 								 ObjectIdGetDatum(RelationGetRelid(rel)),
! 								 0, 0, 0);
! 		if (!HeapTupleIsValid(tup))
! 			elog(ERROR, "RelationRemoveTriggers: relation %u not found in pg_class",
! 				 RelationGetRelid(rel));
  
! 		((Form_pg_class) GETSTRUCT(tup))->reltriggers = 0;
! 		simple_heap_update(pgrel, &tup->t_self, tup);
! 		CatalogOpenIndices(Num_pg_class_indices, Name_pg_class_indices, ridescs);
! 		CatalogIndexInsert(ridescs, Num_pg_class_indices, pgrel, tup);
! 		CatalogCloseIndices(Num_pg_class_indices, ridescs);
! 		heap_freetuple(tup);
! 		heap_close(pgrel, RowExclusiveLock);
! 		CommandCounterIncrement();
! 	}
  
  	/*
! 	 * Also drop all constraint triggers referencing this relation
  	 */
! 	ScanKeyEntryInitialize(&key, 0,
! 						   Anum_pg_trigger_tgconstrrelid,
! 						   F_OIDEQ,
! 						   ObjectIdGetDatum(RelationGetRelid(rel)));
! 	tgscan = systable_beginscan(tgrel, TriggerConstrRelidIndex, true,
! 								SnapshotNow, 1, &key);
! 
! 	while (HeapTupleIsValid(tup = systable_getnext(tgscan)))
! 	{
! 		Form_pg_trigger pg_trigger = (Form_pg_trigger) GETSTRUCT(tup);
  
! 		elog(NOTICE, "DROP TABLE implicitly drops referential integrity trigger from table \"%s\"",
! 			 get_rel_name(pg_trigger->tgrelid));
  
! 		DropTrigger(pg_trigger->tgrelid, NameStr(pg_trigger->tgname));
  
! 		/*
! 		 * Need to do a command counter increment here to show up new
! 		 * pg_class.reltriggers in the next loop iteration (in case there
! 		 * are multiple referential integrity action triggers for the same
! 		 * FK table defined on the PK table).
! 		 */
! 		CommandCounterIncrement();
! 	}
! 	systable_endscan(tgscan);
  
  	heap_close(tgrel, RowExclusiveLock);
  }
  
--- 489,566 ----
  }
  
  /*
!  * DropTriggerById - Drop a trigger by it's OID
   */
  void
! DropTriggerById(Oid trigId, int behavior)
  {
! 	Relation		rel;
! 	Relation		tgrel;
! 	SysScanDesc		tgscan;
! 	ScanKeyData 	key[1];
! 	Relation		pgrel;
! 	HeapTuple		tuple;
! 	Relation		ridescs[Num_pg_class_indices];
! 	Form_pg_trigger	pg_trigger;
! 	Form_pg_class	pg_class;
! 	int				nkeys = 0;
  
+ 	/*
+ 	 * Search pg_trigger, delete target trigger, count remaining triggers
+ 	 * for relation.  Note this is OK only because we have
+ 	 * AccessExclusiveLock on the rel, so no one else is creating/deleting
+ 	 * triggers on this rel at the same time.
+ 	 */
  	tgrel = heap_openr(TriggerRelationName, RowExclusiveLock);
! 	ScanKeyEntryInitialize(&key[nkeys++], 0, ObjectIdAttributeNumber,
  						   F_OIDEQ,
! 						   ObjectIdGetDatum(trigId));
  
! 	tgscan = systable_beginscan(tgrel, 0, false,
! 								SnapshotNow, nkeys, key);
  
! 	tuple = systable_getnext(tgscan);
  
! 	if (!HeapTupleIsValid(tuple))
! 		elog(ERROR, "DropTriggerById: TriggerID %d not valid", trigId);
  
! 	/* Grab the info, and lock the triggers relation */
! 	pg_trigger = (Form_pg_trigger) GETSTRUCT(tuple);
  
! 	rel = heap_open(pg_trigger->tgrelid, AccessExclusiveLock);
  
! 	/* Deal with dependencies */
! 	dependDeleteTuple(tuple, tgrel, behavior);
  
! 	simple_heap_delete(tgrel, &tuple->t_self);
! 
! 	systable_endscan(tgscan);
! 	heap_close(rel, AccessExclusiveLock);
  
  	/*
! 	 * Update relation's pg_class entry.  Crucial side-effect: other
! 	 * backends (and this one too!) are sent SI message to make them
! 	 * rebuild relcache entries.
  	 */
! 	pgrel = heap_openr(RelationRelationName, RowExclusiveLock);
! 	tuple = SearchSysCacheCopy(RELOID,
! 							   ObjectIdGetDatum(RelationGetRelid(rel)),
! 							   0, 0, 0);
! 	if (!HeapTupleIsValid(tuple))
! 		elog(ERROR, "DropTriggerById: relation %s not found in pg_class",
! 			 RelationGetRelationName(rel));
  
! 	pg_class = (Form_pg_class) GETSTRUCT(tuple);
  
! 	pg_class->reltriggers -= 1;
  
! 	simple_heap_update(pgrel, &tuple->t_self, tuple);
! 	CatalogOpenIndices(Num_pg_class_indices, Name_pg_class_indices, ridescs);
! 	CatalogIndexInsert(ridescs, Num_pg_class_indices, pgrel, tuple);
! 	CatalogCloseIndices(Num_pg_class_indices, ridescs);
! 	heap_freetuple(tuple);
  
+ 	heap_close(pgrel, RowExclusiveLock);
  	heap_close(tgrel, RowExclusiveLock);
  }
  
Index: src/backend/commands/typecmds.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/commands/typecmds.c,v
retrieving revision 1.3
diff -c -r1.3 typecmds.c
*** src/backend/commands/typecmds.c	2002/05/03 00:32:16	1.3
--- src/backend/commands/typecmds.c	2002/06/15 16:38:22
***************
*** 35,42 ****
  #include "catalog/catname.h"
  #include "catalog/heap.h"
  #include "catalog/namespace.h"
  #include "catalog/pg_type.h"
- #include "commands/comment.h"
  #include "commands/defrem.h"
  #include "miscadmin.h"
  #include "parser/parse.h"
--- 35,42 ----
  #include "catalog/catname.h"
  #include "catalog/heap.h"
  #include "catalog/namespace.h"
+ #include "catalog/pg_depend.h"
  #include "catalog/pg_type.h"
  #include "commands/defrem.h"
  #include "miscadmin.h"
  #include "parser/parse.h"
***************
*** 268,279 ****
   * only work on scalar types.
   */
  void
! RemoveType(List *names)
  {
  	TypeName   *typename;
- 	Relation	relation;
- 	Oid			typeoid;
- 	HeapTuple	tup;
  
  	/* Make a TypeName so we can use standard type lookup machinery */
  	typename = makeNode(TypeName);
--- 268,276 ----
   * only work on scalar types.
   */
  void
! RemoveType(List *names, int behavior)
  {
  	TypeName   *typename;
  
  	/* Make a TypeName so we can use standard type lookup machinery */
  	typename = makeNode(TypeName);
***************
*** 281,286 ****
--- 278,297 ----
  	typename->typmod = -1;
  	typename->arrayBounds = NIL;
  
+ 	RemoveTypeByTypeName(typename, behavior);
+ }
+ 
+ /*
+  *	TypeRemove
+  *		Removes a datatype by the typename struct
+  */
+ void
+ RemoveTypeByTypeName(TypeName *typename, int behavior)
+ {
+ 	Relation	relation;
+ 	Oid			typeoid;
+ 	HeapTuple	tup;
+ 
  	relation = heap_openr(TypeRelationName, RowExclusiveLock);
  
  	/* Use LookupTypeName here so that shell types can be removed. */
***************
*** 301,331 ****
  		!pg_namespace_ownercheck(((Form_pg_type) GETSTRUCT(tup))->typnamespace,
  								 GetUserId()))
  		aclcheck_error(ACLCHECK_NOT_OWNER, TypeNameToString(typename));
- 
- 	/* Delete any comments associated with this type */
- 	DeleteComments(typeoid, RelationGetRelid(relation));
- 
- 	/* Remove the type tuple from pg_type */
- 	simple_heap_delete(relation, &tup->t_self);
- 
- 	ReleaseSysCache(tup);
- 
- 	/* Now, delete the "array of" that type */
- 	typename->arrayBounds = makeList1(makeInteger(1));
- 
- 	typeoid = LookupTypeName(typename);
- 	if (!OidIsValid(typeoid))
- 		elog(ERROR, "Type \"%s\" does not exist",
- 			 TypeNameToString(typename));
  
! 	tup = SearchSysCache(TYPEOID,
! 						 ObjectIdGetDatum(typeoid),
! 						 0, 0, 0);
! 	if (!HeapTupleIsValid(tup))
! 		elog(ERROR, "Type \"%s\" does not exist",
  			 TypeNameToString(typename));
  
! 	DeleteComments(typeoid, RelationGetRelid(relation));
  
  	simple_heap_delete(relation, &tup->t_self);
  
--- 312,324 ----
  		!pg_namespace_ownercheck(((Form_pg_type) GETSTRUCT(tup))->typnamespace,
  								 GetUserId()))
  		aclcheck_error(ACLCHECK_NOT_OWNER, TypeNameToString(typename));
  
! 	if (!pg_type_ownercheck(typeoid, GetUserId()))
! 		elog(ERROR, "RemoveType: type '%s': permission denied",
  			 TypeNameToString(typename));
  
! 	/* Deal with dependencies */
! 	dependDeleteTuple(tup, relation, behavior);
  
  	simple_heap_delete(relation, &tup->t_self);
  
***************
*** 582,591 ****
  	HeapTuple	tup;
  	char		typtype;
  
- 	/* CASCADE unsupported */
- 	if (behavior == CASCADE)
- 		elog(ERROR, "DROP DOMAIN does not support the CASCADE keyword");
- 
  	/* Make a TypeName so we can use standard type lookup machinery */
  	typename = makeNode(TypeName);
  	typename->names = names;
--- 575,580 ----
***************
*** 616,630 ****
  		elog(ERROR, "%s is not a domain",
  			 TypeNameToString(typename));
  
! 	/* Delete any comments associated with this type */
! 	DeleteComments(typeoid, RelationGetRelid(relation));
  
  	/* Remove the type tuple from pg_type */
  	simple_heap_delete(relation, &tup->t_self);
  
  	ReleaseSysCache(tup);
- 
- 	/* At present, domains don't have associated array types */
  
  	heap_close(relation, RowExclusiveLock);
  }
--- 605,617 ----
  		elog(ERROR, "%s is not a domain",
  			 TypeNameToString(typename));
  
! 	/* Deal with dependencies */
! 	dependDeleteTuple(tup, relation, behavior);
  
  	/* Remove the type tuple from pg_type */
  	simple_heap_delete(relation, &tup->t_self);
  
  	ReleaseSysCache(tup);
  
  	heap_close(relation, RowExclusiveLock);
  }
